#version 150

in vec2 textureCoord;

uniform sampler2D albedo;
uniform vec3 screenGamma;
uniform vec3 color;
uniform bool drawColor;
uniform float smoothing;

const float exposure = 2.0f;

out vec4 fragmentColor;

void main() {
	vec4 colorLinear = texture2D( albedo, textureCoord );

	if ( drawColor ) {
		float alpha = 1.0f;
		if ( smoothing != 0.0f ) {
			float distance = colorLinear.a;
			alpha = smoothstep( 0.5 - smoothing, 0.5 + smoothing, distance );
		}
		colorLinear = vec4( color, alpha );
	}
	// Exposure tone mapping
	vec3 mapped  = vec3( 1.0f ) - exp( -colorLinear.rgb * exposure );
	fragmentColor = vec4( pow( mapped, screenGamma ), colorLinear.a );
}
